package com.yeqifu.bus.service.impl;

import com.yeqifu.bus.entity.Goods;
import com.yeqifu.bus.mapper.GoodsMapper;
import com.yeqifu.bus.service.IGoodsService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.Serializable;
import java.util.List;

/**
 * <p>
 * InnoDB free: 9216 kB; (`providerid`) REFER `warehouse/bus_provider`(`id`) 服务实现类
 * </p>
 *
 * @author luoyi-
 * @since 2019-12-06
 */
@Service
@Transactional
public class GoodsServiceImpl extends ServiceImpl<GoodsMapper, Goods> implements IGoodsService {

    // 保存商品信息，调用父类的保存方法
    @Override
    public boolean save(Goods entity) {
        return super.save(entity);
    }

    // 更新商品信息，调用父类的更新方法
    @Override
    public boolean updateById(Goods entity) {
        return super.updateById(entity);
    }

    // 根据商品id删除商品信息，调用父类的删除方法
    @Override
    public boolean removeById(Serializable id) {
        return super.removeById(id);
    }

    // 根据商品id获取商品信息，调用父类的获取方法
    @Override
    public Goods getById(Serializable id) {
        return super.getById(id);
    }

    /**
     * 根据商品 ID 删除商品信息及相关关联信息
     * @param id 商品的唯一标识符
     */
    @Override
    public void deleteGoodsById(Integer id) {
        //根据商品id删除商品销售信息
        this.getBaseMapper().deleteSaleByGoodsId(id);
        //根据商品id删除商品销售退货信息
        this.getBaseMapper().deleteSaleBackByGoodsId(id);
        //根据商品id删除商品进货信息
        this.getBaseMapper().deleteInportByGoodsId(id);
        //根据商品id删除商品退货信息
        this.getBaseMapper().deleteOutportByGoodsId(id);
        //删除商品信息
        this.removeById(id);
    }

    /**
     * 查询所有库存预警商品
     * @return 包含所有库存预警商品信息的商品列表
     */
    @Override
    public List<Goods> loadAllWarning() {
        // 调用对应的 mapper 中的 loadAllWarning 方法获取库存预警商品列表
        List<Goods> goods = baseMapper.loadAllWarning();
        return goods;
    }
}
